/*
   -
   - The contents of this file are subject to the Mozilla Public License
   - Version 1.1 (the "License"); you may not use this file except in
   - compliance with the License. You may obtain a copy of the License at
   - http://www.mozilla.org/MPL/ 
   - 
   - Software distributed under the License is distributed on an "AS IS" basis,
   - WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
   - for the specific language governing rights and limitations under the
   - License. 
   -
   - The Original Code is Bugxula
   - 
   - The Initial Developer of the Original Code is
   - Netscape Communications Corporation
   - Portions created by Netscape are
   - Copyright (C) 1998 Netscape Communications Corporation.
   - All Rights Reserved.
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU Public License (the "GPL"), in which case the
   - provisions of the GPL are applicable instead of those above.
   - If you wish to allow use of your version of this file only
   - under the terms of the GPL and not to allow others to use your
   - version of this file under the MPL, indicate your decision by
   - deleting the provisions above and replace them with the notice
   - and other provisions required by the GPL.  If you do not delete
   - the provisions above, a recipient may use your version of this
   - file under either the MPL or the GPL.
   -
   - Contributor(s):
   -  
   - Myk Melez, myk@mozilla.org, original author
   - 
*/

// The local bugxula.rdf file containing user preferences, queries, 
// and Bugxula configuration.
var gUserDS = window.opener.gUserDS;
var gQueryURI = gUserDS.generateUniqueURI();
var gInstallations = gUserDS.makeBag(gQueryURI, "bz:installations");
var gFields = ['product', 'component', 'version', 'platform', 'os',
               'status', 'resolution', 'priority', 'severity', 'milestone'];

function onLoad()
{
  // Populate the installations menu with the list of installations.
  var installations = document.getElementById('installations');
  gUserDS.addToDatabase(installations.database);
  installations.builder.rebuild();
  installations.selectedIndex = 0;

  // Add the data source to all fields populated by it.
  var field;
  for ( var i=0 ; i<gFields.length ; i++ )
  {
    field = document.getElementById(gFields[i]);
    field.database.AddDataSource(gUserDS.ds);
    field.setAttribute('ref', gQueryURI);
  }
}

function onUnload()
{
  // Delete the query.
  gInstallations.removeAll();
  gUserDS.unassertResource(gQueryURI, "bz:installations", gInstallations.uri);
  gUserDS.flush();
}

function toggleInstallation(control, event)
{
  if (control.getAttribute('checked'))
    addInstallation(control, event);
  else
    removeInstallation(control, event);
}

function addInstallation(control, event)
{
  var installationURI = control.id;
  
  // Add the installation to the RDF description of the query.
  gInstallations.appendResource(installationURI);

  // Get the installation's configuration data source.
  var configurationURI = installationURI + "config.cgi?ctype=rdf";
  var configuration = window.opener.RDFDataSource.all[configurationURI].ds;

  // Add the data source to all fields populated by it.
  var field;
  for ( i=0 ; i<gFields.length ; i++ )
  {
    field = document.getElementById(gFields[i]);
    field.database.AddDataSource(configuration);
    field.builder.rebuild();
  }
}

function removeInstallation(control, event)
{
  gInstallations.removeResource(control.id);
  //gUserDS.flush();
}
